Whamcloud - gitweb
fa21806d77d13452ec6536064687a6f5eb811d57
[fs/lustre-release.git] / lustrecvs
1 #!/bin/sh
2
3 LC_COLLATE="C"
4 progname="${0##*/}"
5
6 warn ()
7 {
8     [ "$1" ] && echo >&2
9     [ "$1" ] && echo "$progname: $1" >&2
10     [ "$1" ] && echo >&2
11 }
12
13 fatal ()
14 {
15     warn "$2"
16     exit "$1"
17 }
18
19 usage ()
20 {
21     cat <<EOF
22 Usage: $progname <lustretag>
23   where <lustretag> is a tag of the lustre-core module
24 EOF
25 }
26
27 if [ -z "$LUSTRECVS_UPDATED" ] ; then
28     echo "$progname: updating lustrecvs"
29     cvs up -l || fatal 1 "Error updating lustrecvs"
30     export LUSTRECVS_UPDATED=yes
31     exec "$0" "$@"
32 fi
33
34 [ "$1" = "-r" ] && shift
35
36 buildtag="HEAD"
37 lustretag="$1"
38 shift
39
40 if [ "$*" ] ; then
41     usage >&2
42     exit 1
43 fi
44
45
46 case "$lustretag" in
47     '')
48         warn "a lustretag is required."
49         usage >&2
50         exit 1
51         ;;
52     --help | -h)
53         usage
54         exit 0
55         ;;
56
57     # this is the branch table
58     # keep this list sorted alphabetically!
59
60     *)
61         buildtag="HEAD"
62         ;;
63
64 esac
65
66 error_modules=
67 cvs_cmd ()
68 {
69     dir="$1"
70     module="$2"
71     tag="$3"
72     cotag=""
73     update=""
74
75     if [ "$tag" = "HEAD" ] ; then
76         cotag=""
77         uptag="-A"
78     elif [ "$tag" ] ; then
79         cotag="-r $tag"
80         uptag="-r $tag"
81     else
82         # silently skip if no tag was specified
83         return
84     fi
85
86     if [ -d "$dir" ] ; then
87         echo "$progname: Updating $dir to $tag"
88         ( cd "$dir" && cvs up -dP $uptag )
89     else
90         echo "$progname: Checking out $dir from $tag"
91         cvs co -P $cotag -d "$dir" "$module"
92     fi
93     if [ $? != 0 ] ; then
94         error_modules="$dir $error_modules"
95     fi
96 }
97
98 cvs_cmd build lustre-build "" "$buildtag"
99
100 if [ -f build/buildcvs ] ; then
101     . build/buildcvs
102 else
103     fatal 1 "build/buildcvs does not exist; not updating other modules."
104 fi
105
106 if [ "$error_modules" ] ; then
107     fatal 1 "There were errors checking out the following directories: $error_modules"
108 fi